top :-
        'VOID'(_),
        queens(6, _),
        fail.
top.
queens(A, B) :-
        'VOID'(_),
        range(1, A, C),
        queens2(C, [], B).
queens2([], A, A).
queens2(A, B, C) :-
        'VOID'(_),
        select(A, D, E),
        not_attack(B, E),
        queens2(D, [E|B], C).
not_attack(A, B) :-
        'VOID'(_),
        not_attack2(A, B, 1).
not_attack2([], _, _) :-
        'VOID'(_), !.
not_attack2([A|B], C, D) :-
        'VOID'(_),
        C=\=A+D,
        C=\=A-D,
        E is D+1,
        not_attack2(B, C, E).
select([A|B], B, A).
select([A|B], [A|C], D) :-
        'VOID'(_),
        select(B, C, D).
range(A, A, [A]) :-
        'VOID'(_), !.
range(A, B, [A|C]) :-
        'VOID'(_),
        A<B,
        D is A+1,
        range(D, B, C).
