top :-
        'VOID'(A),
        ops8(A, A, A, A),
        log10(A, A, A, A),
        divide10(A, A, A, A).
ops8(_, _, _, _) :-
        'VOID'(A),
        d((x+1)*((x^2+2)*(x^3+3)), x, _, A).
log10(_, _, _, _) :-
        'VOID'(A),
        d(log(log(log(log(log(log(log(log(log(log(x)))))))))), x, _, A).
divide10(_, _, _, _) :-
        'VOID'(A),
        d(x/x/x/x/x/x/x/x/x/x, x, _, A).
d(A+B, C, D+E, _) :-
        'VOID'(F), !,
        d(A, C, D, F),
        d(B, C, E, F).
d(A-B, C, D-E, _) :-
        'VOID'(F), !,
        d(A, C, D, F),
        d(B, C, E, F).
d(A*B, C, D*B+A*E, _) :-
        'VOID'(F), !,
        d(A, C, D, F),
        d(B, C, E, F).
d(A/B, C, (D*B-A*E)/B^2, _) :-
        'VOID'(F), !,
        d(A, C, D, F),
        d(B, C, E, F).
d(A^B, C, D*B*A^E, _) :-
        'VOID'(F), !,
        integer(B),
        E is B-1,
        d(A, C, D, F).
d(-(A), B, -(C), _) :-
        'VOID'(D), !,
        d(A, B, C, D).
d(exp(A), B, exp(A)*C, _) :-
        'VOID'(D), !,
        d(A, B, C, D).
d(log(A), B, C/A, _) :-
        'VOID'(D), !,
        d(A, B, C, D).
d(A, A, 1, _) :-
        'VOID'(_), !.
d(_, _, 0, _).
