% 3 Register, kein Callee Saved (aber intern wird Reg.2 so verwendet)


top:-
    'VOID'(V),
    ops8(V,V,V),
    log10(V,V,V),
    divide10(V,V,V).

ops8(_,_,_) :- 
    d((x+1)*((^(x,2)+2)*(^(x,3)+3)),x,_).

log10(_,_,_) :- 
    d(log(log(log(log(log(log(log(log(log(log(x)))))))))),x,_).

divide10(_,_,_) :- 
    d(((((((((x/x)/x)/x)/x)/x)/x)/x)/x)/x,x,_).

d(U+V,X,DU+DV) :- !, 
    d(U,X,DU),
    'SOURCE'(-,+X2),
    d(V,X2,DV).
d(U-V,X,DU-DV) :- !,
    d(U,X,DU),
    'SOURCE'(-,+X2),
    d(V,X2,DV).
d(U*V,X,DU*V+U*DV) :- !,
    d(U,X,DU),
    'SOURCE'(-,+X2),
    d(V,X2,DV).
d(U/V,X,(DU*V-U*DV)/(^(V,2))) :- !,
    d(U,X,DU),
    'SOURCE'(-,+X2),
    d(V,X2,DV).
d(^(U,N),X,DU*N*(^(U,N1))) :- !, 
    integer(N),
    N1 is N-1,
    d(U,X,DU).
d(-U,X,-DU) :- !,
    d(U,X,DU).
d(exp(U),X,exp(U)*DU) :- !,
    d(U,X,DU).
d(log(U),X,DU/U) :- !,
    d(U,X,DU).
d(X,X,1) :- 
    !, 
    'SINK'(-,+X).
d(_,X,0) :-
    'SINK'(-,+X).
