top :-
        'VOID'(A),
        queens(6, _, A),
        fail.
top.
queens(A, B, _) :-
        'VOID'(_),
        range(1, A, C),
        queens2(C, [], B).
queens2([], A, A).
queens2(A, B, C) :-
        'VOID'(D),
        select(A, E, F),
        not_attack(B, F, D),
        queens2(E, [F|B], C).
not_attack(A, B, _) :-
        'VOID'(_),
        not_attack2(A, B, 1).
not_attack2([], _, _) :-
        'VOID'(_), !.
not_attack2([A|B], C, D) :-
        'VOID'(_),
        C=\=A+D,
        C=\=A-D,
        E is D+1,
        not_attack2(B, C, E).
select([A|B], B, A).
select([A|B], [A|C], D) :-
        'VOID'(_),
        select(B, C, D).
range(A, A, [A]) :-
        'VOID'(_), !.
range(A, B, [A|C]) :-
        'VOID'(_),
        A<B,
        D is A+1,
        range(D, B, C).
